﻿using System;
using System.IO;
using System.Linq;

namespace EF_SalvarImage_BD
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void btnIncluiImagem_Click(object sender, EventArgs e)
        {
            if (fup1.HasFile)
            {
                try
                {
                    string filename = fup1.PostedFile.FileName;
                    int tamanho = fup1.PostedFile.ContentLength;
                    Stream arquivoStream = fup1.PostedFile.InputStream;

                    if (SalvarImagem(arquivoStream, filename, tamanho))
                    {
                        lblStatus.Text += "Imagem salva com sucesso no banco de dados";
                    }
                    else
                    {
                        lblStatus.Text += "FALHA ao salvar a imagem no Banco de dados";
                    }
                }
                catch (Exception ex)
                {
                    lblStatus.Text = " Erro " + ex.Message;
                }
            }
        }

        private bool SalvarImagem(Stream arquivoStream, string filename, int tamanho)
        {
            bool ret = false;

            try
            {
                byte[] documentBytes = new byte[arquivoStream.Length];
                arquivoStream.Read(documentBytes, 0, documentBytes.Length);

                MinhaFoto foto = new MinhaFoto()
                {
                    Nome = filename,
                    Descricao = txtDescricao.Text,
                    Foto = documentBytes,
                    Tamanho = tamanho
                };

                using (CadastroEntities ctx = new CadastroEntities())
                {
                    ctx.MinhasFotos.Add(foto);
                    ctx.SaveChanges();
                    ret = true;
                }
            }
            catch (Exception ex)
            {
                lblStatus.Text = " Erro : " + ex.Message;
            }
            return ret;
        }

        protected void btnExibirDados_Click(object sender, EventArgs e)
        {
            try
            {
                using (CadastroEntities ctx = new CadastroEntities())
                {
                    gdvFotos.DataSource = from reg in ctx.MinhasFotos.ToList() select reg;
                    gdvFotos.DataBind();
                }
            }
            catch(Exception ex)
            {
                lblStatus.Text = " Erro : " + ex.Message;
            }
        }

        protected void btnExibirFoto_Click(object sender, System.EventArgs e)
        {
            try
            {
                int codigo = Convert.ToInt32(gdvFotos.SelectedRow.Cells[1].Text);
                byte[] bytes = (byte[])carregaImagem(codigo);
                string base64String = Convert.ToBase64String(bytes, 0, bytes.Length);
                imgFoto.ImageUrl = "data:image/png;base64," + base64String;
            }
            catch(Exception ex)
            {
                lblStatus.Text = " Erro " + ex.Message;
            }
        }

        private byte[] carregaImagem(int id)
        {   
            try
            {
                byte[] fileBytes = null;
                using (CadastroEntities ctx = new CadastroEntities())
                {   
                    var dbInfo = ctx.MinhasFotos.FirstOrDefault(doc => doc.Id == id);
                    if (dbInfo != null)
                    {
                        fileBytes = dbInfo.Foto;
                    }
                }
                return fileBytes;
            }           
            catch(Exception ex)
            {
                throw ex;
            }
        }
    }
}